<?php  //$Id: upgrade.php,v 1.1.2.2 2006/10/26 17:43:05 stronk7 Exp $

// This file keeps track of upgrades to 
// the stupla module
//
// Sometimes, changes between versions involve
// alterations to database structures and other
// major things that may break installations.
//
// The upgrade function in this file will attempt
// to perform all the necessary actions to upgrade
// your older installtion to the current version.
//
// If there's something it cannot do itself, it
// will tell you what you need to do.
//
// The commands in here will all be database-neutral,
// using the functions defined in lib/ddllib.php

function xmldb_stupla_upgrade($oldversion=0) {

	global $CFG, $THEME, $db;

	$result = true;

	if ($result && $oldversion < 2010110100) {

		// add flags to stupla session 
		$table = new XMLDBTable('stupla_session');
		$field = new XMLDBField('flags');
		$field->setAttributes(XMLDB_TYPE_INTEGER, 2, XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, 0, 'starttime');
		$result = $result && add_field($table, $field);

	}

	return $result;
}

?>
